unit irrigation;

interface

uses WinDows,sysutils,math;

implementation


{***************************************************************************}
{*                             main program                                *}
{***************************************************************************}


const   maxo   = 10;
	maxmo  = 1000;
        maxsub = 100;
        maxs   = 43;

var
 noauslass,nomonths,
 nosub,nooases,noyears,anz,
 i,j,k,l,m 		        : longint;
 in1,in2,ou1,ou2    	        : text;
 zeile,zeile1		        : string;
 startd,                        
 z10			        : string[10];
 z5			        : string[5];
 names			        : array[1..maxo] of string[10];
 noabzug	                : array[1..maxo,1..maxo] of integer;
 nosubse,                       
 noreach                        : array[1..maxo] of integer;

 verdunst,elevation,entnahme,
 size, soil_w, soil_i,soilstom,
 soilsto, irr_frac, irr_eff     : array[0..maxo] of real;
 ar1			        : array[1..3,1..maxsub] of integer;
 ar2,ar3,ar4         	        : array[1..maxs,1..maxsub] of real;
 datum                          : array[1..maxmo]of string[10];
 rain,demand			: array[1..maxmo,1..maxo] of real;
 lang			        : array[1..12] of integer;

 rain_eff,
 bedarf, durchfluss,
 totalentnahme          : real;

 found			: boolean;




begin

entnahme[0]:=0;

lang[1]:=31;
lang[2]:=28;
lang[3]:=31;
lang[4]:=30;
lang[5]:=31;
lang[6]:=30;
lang[7]:=31;
lang[8]:=31;
lang[9]:=30;
lang[10]:=31;
lang[11]:=30;
lang[12]:=31;


(* Kopieren von output.rch' *)
assign(in2,'output.rch');
assign(ou1,'output.rrr');
reset(in2);
rewrite(ou1);
repeat
 read(in2,zeile);
 write(ou1,zeile);
 if eoln(in2)then
  begin
   readln(in2);
   writeln(ou1);
  end;

until eof(in2);
close(in2);
close(ou1);

(* Lesen Eingabedateien *)

assign(in1,'irrigation.in');
reset(in1);

readln(in1,nosub);
readln(in1,nooases);
readln(in1, nomonths,noyears);
readln(in1,startd);
readln(in1,noauslass);

for i:=1 to nooases do
 read(in1,names[i]);
readln(in1);

for i:=1 to nooases do
 read(in1,noreach[i]);
readln(in1);

for i:=1 to nooases do
 begin
  read(in1,j,nosubse[j]);
  for m:=1 to nosubse[j] do
   read(in1,noabzug[i,m]);
  readln(in1);
 end;

for i:=1 to nooases do
 read(in1,size[i]);
readln(in1);

for i:=1 to nooases do
 read(in1,elevation[i]);
readln(in1);

for i:=1 to nooases do
 read(in1,soil_w[i]);
readln(in1);

for i:=1 to nooases do
 read(in1,soil_i[i]);
readln(in1);

for i:=1 to nooases do
 read(in1,irr_frac[i]);
readln(in1);

for i:=1 to nooases do
 read(in1,irr_eff[i]);
readln(in1,rain_eff);

for i:=1 to nooases do
 begin
  soilsto[i] :=size[i]*soil_w[i]/1000*soil_i[i]/100;
  soilstom[i]:=size[i]*soil_w[i]/1000;
 end;

 readln(in1);
 for i:=1 to maxmo do
  begin
   datum[i]:='####      ';
   for j:=1 to maxo do 
    begin
     demand[i,j]:=0;
     rain[i,j]:=0;
    end; 
  end;
  
  found:=false;
  repeat
   read(in1,datum[1]);
   if pos(datum[1],startd)<>0 then
    begin
     for j:=1 to nooases do                            
      read(in1,demand[1,j]);    
     for j:=1 to nooases do                               
      read(in1,rain[1,j]);      
     found:=true;
    end;
   readln(in1);
   if eof(in1) then
    begin
     writeln(' Startdatum nicht gefunden');
     readln;
     halt;
    end;
  until found or eof(in1);

 for i:=2 to nomonths do
  begin
   read(in1,datum[i]);
   for j:=1 to nooases do
    read(in1,demand[i,j]);  
   for j:=1 to nooases do     
    read(in1,rain[i,j]);   
   readln(in1);
  end;

close(in1);

(* nun geht es los *);

assign(in1,'output.rrr');
assign(ou1,'output.rch');
assign(ou2,'irrigation.out');
reset(in1);
rewrite(ou1);
rewrite(ou2);

z10:=' ';
write(ou2,z10:10,'  ');
for i:=1 to nooases do
 begin
  write(ou2,'  s_',names[i]:10);
 end;
for i:=1 to nooases do
 begin
  write(ou2,'  e_',names[i]:10);
 end;
for i:=1 to nooases do
 begin
  write(ou2,'  v_',names[i]:10);
 end;
for i:=1 to nooases do
 begin
  write(ou2,'  f_',names[i]:10);
 end; 
write(ou2,'  f_outlet':10);
writeln(ou2);

for i:=1 to 8 do
 begin
  readln(in1,zeile);
  writeln(ou1,zeile);
 end;
 read(in1,zeile);
 write(ou1,zeile);
 readln(in1,zeile);
 writeln(ou1,zeile);

anz:=0;

for i:=1 to maxs do
 for j:=1 to maxsub do
  begin
   ar3[i,j]:=0;
   ar4[i,j]:=0;
  end;

repeat

 for j:=1 to nosub do
  begin
   read(in1,z5);
   for i:=1 to 3 do
    read(in1,ar1[i,j]);
   For i:=1 to maxs do
    read(in1,ar2[i,j]);
   readln(in1);
  end;

 if (ar1[3,nosub]<1900) then inc(anz);


(* nun berechnen *)

  totalentnahme:=0;
  if (ar1[3,1]<nosub+1) then
   begin
    for i:=1 to nooases do
     begin
      j:=noreach[i];
      durchfluss   :=ar2[3,j]*86400*lang[ar1[3,1]]/1000000; (* m3 im Mio m3/month *)
      entnahme[i]  :=min(durchfluss*irr_frac[i],soilstom[i]-soilsto[i]) ;
      bedarf       :=demand[anz,i]/irr_eff[i];
      verdunst[i]  :=min(bedarf,soilsto[i]+entnahme[i]);
      soilsto[i]   :=soilsto[i]+rain[anz,i]*rain_eff*size[i]/1000+entnahme[i]-verdunst[i];
      if soilsto[i]<0 then soilsto[i]:=0;
      for m:=1 to nosubse[i] do
       begin
        k:=noabzug[i,m];
        ar2[3,k]:=ar2[3,k]-entnahme[i]/86400/lang[ar1[3,1]]*1000000; (* nun Abfluss reduzieren*)
       end;
      totalentnahme:=totalentnahme+entnahme[i];
     end; 
(*
     ar2[3,noauslass]:=ar2[3,noauslass]-totalentnahme/86400/lang[ar1[3,1]]*1000000;
     writeln(totalentnahme);
*)
   end;

(* und dann rausschreiben *)

 if (ar1[3,nosub]<nosub+1) then
  begin
   write(ou2,' ',datum[anz]:10);
   for i:=1 to nooases do
    write(ou2,'  ',soilsto[i]:12);
   for i:=1 to nooases do
    write(ou2,'  ',entnahme[i]:12);
   for i:=1 to nooases do
    write(ou2,'  ',verdunst[i]:12);
   for i:=1 to nooases do
    write(ou2,'  ',ar2[3,noreach[i]]:12);
   write(ou2,'  ',ar2[3,noauslass]:12);
   writeln(ou2);

   for j:=1 to nosub do
     begin
     write(ou1,z5,ar1[1,j]:5,ar1[2,j]:9,ar1[3,j]:6);
     For i:=1 to maxs do
      write(ou1,ar2[i,j]:12);
     writeln(ou1);
    end;
   for j:=1 to nosub do
     begin
      ar3[1,j]:=ar2[1,j];
      ar4[1,j]:=ar2[1,j];
      for l:=2 to maxs do
       begin
        ar3[l,j]:=ar3[l,j]+ar2[l,j]/12;
        ar4[l,j]:=ar4[l,j]+ar2[l,j];
       end;
     end;
  end
 else
   begin
     for j:=1 to nosub do
      begin
       write(ou1,z5,ar1[1,j]:5,ar1[2,j]:9,ar1[3,j]:6);
       For i:=1 to maxs do
        write(ou1,ar3[i,j]:12);
       writeln(ou1);
      end;
     for i:=1 to maxs do
     for j:=1 to maxsub do
       ar3[i,j]:=0;
   end;

  if (ar1[1,nosub]=nosub) and (ar1[3,nosub]=noyears) then
   begin
    for j:=1 to nosub do
     begin
      write(ou1,z5,ar1[1,j]:5,ar1[2,j]:9,anz/12:6:1);
      For i:=1 to maxs do
       write(ou1,ar4[i,j]/nomonths:12);
      writeln(ou1);
     end;
    close(ou1);
    close(ou2);
    halt;
   end;

until eof(in1);


close(in1);
close(ou1);
close(ou2);

end.
