      subroutine parasol(nopt,iobj,isens)
!     subroutine parasol(iclb,nopt)
      use parm
!     !  !         !         !         !         !         !         ! !
c	Main program for the optimisation and uncertainty analysis

!!    iobj         |none          |number of objective functions
!!    obj(:)       |none          |values of the objective functions
!!    iclb         |none          |method to form GOC out of objective functions
!!    icalpar(:,:) |none          |objective functions codes of OBJMET.DAT
!!    iitel        |none          |number of simulation run
!!    iinr(:)      !              |number of HRUs to change for parameter (:)
!!    inrhru(:,:)  |none          |list of HRU numbers to change  

c     AVG



!     !  !         !         !         !         !         !         ! !
      implicit real*8 (a-h,o-z)
      integer icalpar(4,iobj), iobj, isenspar(4,isens), imet(nopt),isens
      integer  iiname(nopt), iinr(nopt), inrhru(nopt,2000),nobs(iobj)
	integer icd,npsmaxn,kstop,icalml
	integer nopt,npt,nintval,igoc,ngs,npg,nps,nspl,istat, iprob
      real*8 a(100), bbound(2,nopt), sensw(isens), omin(iobj),
     *	bestf, varobj(iobj),aveval(iobj), varval(iobj)
      real*8 valmin(iobj), valmax(iobj), xxo(nopt),pcento
      character*10 pcntrl,deflt,usrsp, parname(nopt)
      character*8 reduc,initl,ysflg,noflg
      data deflt/' DEFAULT  '/
      data usrsp/'USER SPEC.'/
      data ysflg/'YES '/
      data noflg/'NO  '/
	 character*4 fmnname(40), fmxname(40), tt
        data fmnname /'mn01','mn02','mn03','mn04','mn05','mn06','mn07',
     &'mn08','mn09','mn10','mn11','mn12','mn13','mn14','mn15','mn16',
     &'mn17','mn18','mn19','mn20','mn21','mn22','mn23',
     &'mn24','mn25','mn26','mn27','mn28','mn29','mn30','mn31','mn32',
     &'mn33','mn34','mn35','mn36','mn37','mn38','mn39','mn40'/
       data fmxname /'mx01','mx02','mx03','mx04','mx05','mx06','mx07',
     &'mx08','mx09','mx10','mx11','mx12','mx13','mx14','mx15','mx16',
     &'mx17','mx18','mx19','mx20','mx21','mx22','mx23',
     &'mx24','mx25','mx26','mx27','mx28','mx29','mx30','mx31','mx32',
     &'mx33','mx34','mx35','mx36','mx37','mx38','mx39','mx40'/
      common /iopar/ in,iprii
	

      open(18009,file='parasolin.dat',status='old')
      open(18011,file='parasolout.out',status='unknown')
      open(18012, file='sceobjf.out')
	open(18014, file='sceresponse.out')
      open(18013, file='scepar.out')
      open(18018, file='sceparobj.dat')
	open(18019, file='scegoc.out')
	open(19014, file='uncresponse.out')
      open(19013, file='goodpar.out')
      open(19012, file='uncobjf.out')
	open(18020,file='bestpar.out')
	open(19020,file='test.out')
		iprii=18011
	call readchangepar(bbound,nopt,iiname,iinr, inrhru,imet,parname)
	call readmetfiles(iobj,calw, icalpar,isenspar,sensw,
     *	isens)
	call parasolin(maxn,kstop,pcento,iseed,nopt,iobj,npt,
     &  nintval,igoc,ngs,npg,nps,nspl,istat, iprob)

	call countobs(nobs,iobj, icalpar,aveval,varval)

	write(18011, *) 'OF   # obs| average |variance    '
	do ii=1,iobj
	write(18011,121) ii, nobs(ii), aveval(ii),varval(ii)
121   format(i5,i5,2e11.3)
	end do
	ipr=0
	icd=0
c	go to 66
c
c	calling subroutine to optimise for all the objective functions
      call parasolopt(nopt,iobj,isens, npt,icd,ngs,npg,nps,nspl,
     *	maxn,kstop,pcento,iseed,igoc,icalml,iiname, bbound,
     * iinr, inrhru, icalpar, sensw, isenspar,
     *bestf, imet,omin,nobs,varval,iprob,istat)
	write(18011, *)
	write(18011, *) '*** AUTOCALIBRATION SUCCESSFULLY ENDED ***'
	write(18011, *)
	call parasolunc(iobj,igoc,nopt,icalml,istat, iprob,bbound,
     *	parname, ntot,omin,nobs,nintval, iiname, inrhru, iinr,
     *isens,icalpar, isenspar, sensw, imet)
      close(18011)
      close(18012)
      close(18013)
	close(18014)
      close(18016)
	close(18017)
	close(18018)
	close(18019)
	close(18020)
      close(19012)
      close(19013)
	close(19014)
66	continue


	



	if (iclb.eq.3) then
c	calling subroutine to analyse selection to compute uncertainty

c  START RUNNING GOODPAR.OUT
	write(*,*) 'start rerunning goodpar.out parameter sets....'
      open(18010,file='batchin.dat',status='old')
      open(18011,file='batchout.dat',status='unknown')
      open(18012, file='batchobjf.out')
      open(18013, file='batchpar.out')
      open(18015, file='goodpar.out')
	open(18014, file='batchrespons.out')
	open (18118, file='minval.out')
	open (18119, file='maxval.out')
	icd=2
	icalml=0
	ipr=0
5	read(18015,8013, end =4) i, (xxo(ii), ii=1,nopt)
8013  format(i5, 100e12.5)
	icalml=icalml+1
      call rerun(xxo, nopt,iiname, inrhru, iinr, icalml, imet,ipr)
      call objfunctn(obj, iobj, icalpar, icalml,icd)
	call response(sensw, isens, isenspar, icalml)
	go to 5
4	continue	


	do ii=1,iobj
	tt=fmnname(ii)
	open(7700+ii,file=tt) 
	tt=fmxname(ii)
	open(7800+ii,file=tt) 
	end do
8	do ii=1,iobj
	read(7700+ii,5000,end=7) iyr, iday, ihr, valmin(ii)
	read(7800+ii,5000,end=7) iyr, iday, ihr, valmax(ii)
5000  format(1x,i4,2x,i3,1x,i2,22e10.3)	
	end do
	write(18118,5001) iyr, iday, ihr,(valmin(ii), ii=1,iobj)
	write(18119,5001)iyr, iday, ihr, (valmax(ii), ii=1,iobj)
5001	format(1x,i4,2x,i3,1x,i2,100e10.3)
	go to 8
7	continue
	do ii=1,iobj
	close(7700+ii) 
	close(7800+ii) 
	end do
	close(18010)
      close(18011)
      close(18012)
      close(18013)
	close(18014)
	close(18015)
      close(18118)
	close(18119)

	end if
	write(*,*) "ParaSol is rerunning the best parameter set"
	open(18020,file='bestpar.out')
	read(18020,8013) iitel, (xxo(ii), ii=1,nopt)
	ipr=1
      call rerun(xxo, nopt,iiname, inrhru, iinr, iitel, imet,ipr)
	close(18020)
      return
	end



ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc


!     !  !         !         !         !         !         !         ! !
      
	subroutine parasolin(maxn,kstop,pcento,iseed,nopt,iobj,npt,
     &  nintval,igoc,ngs,npg,nps,nspl, istat, iprob)
	
c   THIS SUBROUTINE READS AND PRINTS THE INPUT VARIABLES FOR
c   PARASOL METHOD FOR GLOBAL OPTIMIZATION
c
c   WRITTEN BY QINGYUN DUAN - UNIVERSITY OF ARIZONA, APRIL 1992
c   Modified by Ann van Griensven - UNIVERSITY OF CALIFORNIA RIVERSIDE, APRIL 2003
c
c

!     !  !         !         !         !         !         !         ! !
      implicit real*8 (a-h,o-z)
	integer nopt,npt,nintval,igoc,ngs,npg,nps,nspl,istat, iprob
      character*10 pcntrl,deflt,usrsp,  pname
      character*8 reduc,initl,ysflg,noflg
      data deflt/' DEFAULT  '/
      data usrsp/'USER SPEC.'/
      data ysflg/'YES '/
      data noflg/'NO  '/
c
      write (*,*) ' ENTER THE SCEIN SUBROUTINE --- '
c

c
c  INITIALIZE I/O VARIABLES
c
      ierror = 0
      iwarn = 0


        write(18011,*) " sce control parameters "
	
       ideflt = 0
      read(18009,*) maxn
	read(18009,*) kstop
	read(18009,*) pcento
	read(18009,*) ngs
	read(18009,*) iseed
      if (iseed .eq. 0) iseed = 1969
	read(18009,*) 
	read(18009,*) 
	read(18009,*) nspl
	read(18009,*) istat
	read(18009,*) iprob
	read(18009,*) igoc
	if (igoc.eq.0) igoc=iobj

	read(18009,*) nintval


      noptmax=min(nopt,16)
        npg = 2*noptmax + 1
        nps = noptmax + 1
        nspl = npg



c  CHECK IF THE SCE CONTROL PARAMETERS ARE VALID
      if (ngs .lt. 1 .or. ngs .ge. 1320) then
        write(18011,900) ngs
  900   format(//,1x,'**ERROR** NUMBER OF COMPLEXES IN INITIAL ',
     *         ' POPULATION ',i5,' IS NOT A VALID CHOICE')
        ierror = ierror + 1
      end if
c
      if (kstop .lt. 0 .or. kstop .ge. 20) then
        write(18011,901) kstop
  901   format(//,1x,'**WARNING** THE NUMBER OF SHUFFLING LOOPS IN',
     *  ' WHICH THE CRITERION VALUE MUST CHANGE ',/,13x,'SHOULD BE',
     *  ' GREATER THAN 0 AND LESS THAN 10.  ','kstop = ',i2,
     *  ' WAS SPECIFIED.'/,13x,'BUT kstop = 5 WILL BE USED INSTEAD.')
        iwarn = iwarn + 1
        kstop=5
      end if


c
      if (nspl .lt. 1) then
        write(18011,905) nspl
  905   format(//,1x,'**WARNING** THE NUMBER OF EVOLUTION STEPS ',
     *         'TAKEN IN EACH COMPLEX BEFORE SHUFFLING ',I4,/,13x,
     *         'IS NOT A VALID CHOICE, SET IT TO DEFAULT')
        iwarn = iwarn + 1
        nspl = npg
      end if
c
c  COMPUTE THE TOTAL NUMBER OF POINTS IN INITIAL POPULATION

      npt = ngs * npg


c
c  PRINT OUT THE TOTAL NUMBER OF ERROR AND WARNING MESSAGES
      if (ierror .ge. 1) write(18011,907) ierror
  907 format(//,1x,'*** TOTAL NUMBER OF ERROR MESSAGES IS ',i2)
c
      if (iwarn .ge. 1) write(18011,908) iwarn
  908 format(//,1x,'*** TOTAL NUMBER OF WARNING MESSAGES IS ',i2)
c


c
c
c  PRINT SHUFFLED COMPLEX EVOLUTION OPTIMIZATION OPTIONS
  104 write(18011,910)
  910 format(//,2x,'SCE CONTROL',5x,'MAX TRIALS',5x,
     &'REQUIRED IMPROVEMENT',5x,'RANDOM',/,3x,'PARAMETER',8x,
     &'ALLOWED',6x,'PERCENT',4x,'NO. LOOPS',6x,'SEED',/,
     &2x,11(1h-),5x,10(1H-),5x,7(1h-),4x,9(1h-),5x,6(1h-))
c
      pcenta=pcento*100.
      write(18011,912) pcntrl,maxn,pcenta,kstop,iseed
  912 format(3x,a10,7x,i5,10x,f3.1,9x,i2,9x,i5)
      write(18011,914) ngs,npg,npt,nps,nspl
  914 format(//,18x,'SCE ALGORITHM CONTROL PARAMETERS',/,18x,32(1H=),
     &//,2x,'NUMBER OF',5x,'POINTS PER',5x,'POINTS IN',6x,'POINTS PER',
     &4x,'EVOL. STEPS',/,2x,'COMPLEXES',6X,'COMPLEX',6x,'INI. POPUL.',
     &5x,'SUB-COMPLX',4x,'PER COMPLEX',/,2x,9(1h-),5x,10(1h-),4x,
     &11(1h-),5x,10(1h-),4x,11(1h-),5x,/,2x,5(i5,10x))
      write(18011,916)
  916 format(//,8x,'INITIAL PARAMETER VALUES AND PARAMETER BOUNDS',/,
     &       8x,45(1h=),//,2x,'PARAMETER',5x,'INITIAL VALUE',5x,
     &       'LOWER BOUND',5x,'UPPER BOUND',/,2x,9(1h-),5x,13(1h-),5x,
     &       11(1h-),5x,11(1h-))
      if (ierror .ge. 1) then
      write(18011,922)
  922 format(//,'*** THE OPTIMIZATION SEARCH IS NOT CONDUCTED BECAUSE',
     &       ' OF INPUT DATA ERROR ***')
      end if

c
C  END OF SUBROUTINE SCEIN

      return
      end

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      subroutine parasolopt(nopt,iobj,isens, npt,icd,ngs,npg,nps,nspl,
     *	maxn,kstop,pcento,iseed,igoc,icalml,iiname, bbound,
     * iinr, inrhru, icalpar, sensw, isenspar,
     * bestf, imet,omin,nobs,varval,iprob,istat)

c
c  SHUFFLED COMPLEX EVOLUTION METHOD FOR GLOBAL OPTIMIZATION
c     -- Version 2.2
c
c  by QINGYUN DUAN
c  National Weather Service, NOAA
c  GCIP Climate Project
c  1325 East-West Highway
c  Silver Spring, MD 20910
c  (301) 713-1018, email: qduan@smtpgate.ssmc.noaa.gov
c
c  WRITTEN IN OCTOBER 1990.
c  REVISED IN AUGUST 1991
c  REVISED IN APRIL 1992
c
c  ADAPTED BY ANN VAN GRIENSVEN IN APRIL 2003
c                 University of California, Riverside
c
c  STATEMENT BY AUTHOR:
c  --------------------
c
c     This general purpose global optimization program is developed at
c     the Department of Hydrology & Water Resources of the University
c     of Arizona.  Further information regarding the SCE-UA method can
c     be obtained from Dr. Q. Duan, Dr. S. Sorooshian or Dr. V.K. Gupta
c     at the address and phone number listed above.  We request all
c     users of this program make proper reference to the paper entitled
c     'Effective and Efficient Global Optimization for Conceptual
c     Rainfall-runoff Models' by Duan, Q., S. Sorooshian, and V.K. Gupta,
c     Water Resources Research, Vol 28(4), pp.1015-1031, 1992.
c
c
c  LIST OF INPUT ARGUEMENT VARIABLES
c
c     a(.) = initial parameter set
c     bl(.) = lower bound on parameters
c     bu(.) = upper bound on parameters
c     nopt = number of parameters to be optimized
c
c
c  LIST OF SCE ALGORITHMIC CONTROL PARAMETERS:
c
c     ngs = number of complexes in the initial population
c     npg = number of points in each complex
c     npt = total number of points in initial population (npt=ngs*npg)
c     nps = number of points in a sub-complex
c     nspl = number of evolution steps allowed for each complex before
c         complex shuffling
c     iseed = initial random seed
c
c  CONVERGENCE CHECK PARAMETERS
c
c     maxn = max no. of trials allowed before optimization is terminated
c     kstop = number of shuffling loops in which the criterion value must
c         chang by the given percentage before optimization is terminated
c     pcento = percentage by which the criterion value must change in
c         given number of shuffling loops
c     ipcnvg = flag indicating whether parameter convergence is reached
c         (i.e., check if gnrng is less than 0.001)
c         = 0, parameter convergence not satisfied
c         = 1, parameter convergence satisfied
c
c
c  LIST OF LOCAL VARIABLES
c     x(.,.) = coordinates of points in the population
c     xf(.) = function values of x(.,.)
c     xx(.) = coordinates of a single point in x
c     cx(.,.) = coordinates of points in a complex
c     cfq(.) = function values of cx(.,.)
c     s(.,.) = coordinates of points in the current simplex
c     sf(.) = function values of s(.,.)
c     bestx(.) = best point at current shuffling loop
c     bestf = function value of bestx(.)
c     worstx(.) = worst point at current shuffling loop
c     worstf = function value of worstx(.)
c     xnstd(.) = standard deviation of parameters in the population
c     gnrng = normalized geometric mean of parameter ranges
c     lcs(.) = indices locating position of s(.,.) in x(.,.)
c     bound(.) = bound on ith variable being optimized
c     ngs1 = number of complexes in current population
c     ngs2 = number of complexes in last population
c     iseed1 = current random seed
c     criter(.) = vector containing the best criterion values of the last
c         10 shuffling loops
c
c
c     AVG
!!    noptz        |none          |number of parameters to optimise
!!    xxo(:)       |none          |new values of the parameters 
!!    iiname(:)    |none          |code refering to which parameter to change, and how
!!    iobj         |none          |number of objective functions
!!    iniobj(:)    |none          |values of the objective functions of the initial run
!!    obj(:)       |none          |values of the objective functions
!!    icalw        |none          |weight given for the objectives
!!    wgoc         |none          |calculated GOC
!!    icalpar(:,:) |none          |objective functions codes of CALMET.DAT
!!    icalml       |none          |number of simulation run
!!    iinr(:)      !              |number of HRUs to change for parameter (:)
!!    inrhru(:,:)  |none          |list of HRU numbers to change  
!!    obj(:)       |none          |values of the objective functions
!!    ffz(:)       |none          |transformed objectif function

c     AVG

c  ARRAYS FROM THE INPUT DATA
      implicit real*8 (a-h,o-z)
      real*8 a(nopt)
      integer inrhru(nopt,2000), npt1,nopt,iobj, imet(nopt), nobs(iobj)
      integer icalpar(4,iobj),iiname(nopt), iinr(nopt),lcs(50)
	integer isens, isenspar(4,isens),igoc, npt,icd,iprob,istat
c
c  LOCAL ARRAYS
      real*8 x(npt,nopt), xx(nopt),bestx(nopt),worstx(nopt),xf(npt)
     *,snew(nopt), bbound(2,nopt), xxo(nopt)
      real*8 s(nps,100),sf(nps),cx(npg,100),cfq(npg), calw(iobj)
      real*8 xnstd(100),bound(nopt),criter(20),unit(100)
      real*8 obj(iobj), iniobjf(iobj),omin(iobj), varobj(igoc)
	real*8 criteromin(20,igoc), bbound2(2,nopt),varval(iobj)
      real*8 ffz(iobj), bu(nopt),bl(nopt),fa,fnew, sensw(isens)
	real*8 xfz(npt,igoc), sfz(nps,igoc), cfzq(npg,igoc), vartot
	integer ic(npt), is(nps), ix(npt)
	character*10 parname(nopt)
c
cc

      write (*,*) ' ENTER THE SCEUA SUBROUTINE --- '     


c  ALGORITHM GENERATE A NEW POINT(S) FROM A SUB-COMPLEX
c
c  SUB-COMPLEX VARIABLES
c


c  INITIALIZE VARIABLES
      iitel = 0
      nloop = 0
      loop = 0
      igs = 0
      nopt1 = 8
      if (nopt.lt.8) nopt1 = nopt
      nopt2 = 12
      if (nopt.lt.12) nopt2 = nopt
        do ik=1,nopt
        bl(ik)=bbound(1,ik)
        bu(ik)=bbound(2,ik)
        end do


c
c  INITIALIZE RANDOM SEED TO A NEGATIVE INTEGER
      iseed1 = -abs(iseed)
c
c  COMPUTE THE TOTAL NUMBER OF POINTS IN INITIAL POPUALTION

      npt = ngs * npg
      ngs1 = ngs
      npt1 = npt
c
      write(18011,400)
      write (*,*) ' ***  Evolution Loop Number ',nloop
c
c  COMPUTE THE BOUND FOR PARAMETERS BEING OPTIMIZED
      do j = 1, nopt
        bound(j) = bbound(2,j) - bbound(1,j)
        unit(j) = 1.0
      end do
c
c  COMPUTE THE FUNCTION VALUE OF THE INITIAL POINT
      icalml = 0
      call objfunctn(obj,iobj, icalpar, icalml,icd)
	

      if (icalml .ge. maxn) go to 9000
       do mm=1,igoc
      omin(mm)=obj(mm)
      iniobjf(mm)= obj(mm)
	
       end do
	do ii=1,iobj
	if (icalpar(2,ii).eq.1) then
	vv= 1.-omin(ii)/nobs(ii)/varval(ii)	
	write(18011,*)'Initial Nash-Sutcliff efficiency of OF ',ii,
     *	'=',vv
	end if
	end do
c
c  PRINT THE INITIAL POINT AND ITS CRITERION VALUE


c
c  GENERATE AN INITIAL SET OF npt1 POINTS IN THE PARAMETER SPACE

c
c  ELSE, GENERATE A POINT RANDOMLY AND SET IT EQUAL TO x(1,.)

c
c  GENERATE npt1-1 RANDOM POINTS DISTRIBUTED UNIFORMLY IN THE PARAMETER
c  SPACE, AND COMPUTE THE CORRESPONDING FUNCTION VALUES
	 do i = 1, npt1
	icalml = icalml + 1
        call getpnt(nopt,1,iseed1,xx,bl,bu,unit,bl)
        do j = 1, nopt
          x(i,j) = xx(j)
        end do
        xxo=xx
	call functn(xxo,nopt, iiname, inrhru, iinr, icalml,iobj,
     *	 icalpar, isens, isenspar, sensw,obj, imet,icd)
       do mm=1,igoc
        xfz(i,mm)= obj(mm)
        omin(mm)=min(omin(mm), obj(mm))
       end do

        if (icalml .ge. maxn) then
          npt1 = i
          go to 45
        end if
      end do

	vartot=0.
	do mm=1,igoc
	varobj(mm)=omin(mm)/nobs(mm)
	vartot=vartot+varobj(mm)
	end do
	fa=0.
	do mm=1,igoc
	  ffz(mm)=obj(mm)/(varobj(mm)*2)
	  fa=fa+ffz(mm)
	end do
	fa=fa*vartot
        i=0
        write(18019,6666) i, (ffz(mm), mm=1,igoc), fa
6666    format(i5, 41e12.5)	
        do i=1, npt1
        xf(i)=0. 
        ix(i)=i
        do mm=1,igoc
        obj(mm)=xfz(i,mm)
	  ffz(mm)=obj(mm)/(varobj(mm)*2)
	  xf(i)= xf(i)+ffz(mm)
        end do
	  xf(i)=xf(i)*vartot

        write(18019,6666) i, (ffz(mm), mm=1,igoc), xf(i)
        end do

c	
c  ARRANGE THE POINTS IN ORDER OF INCREASING FUNCTION VALUE
   45 call sort3(npt1,nopt,x,xf,xfz,ix,igoc)
c
c  RECORD THE BEST AND WORST POINTS
      do j = 1, nopt
        bestx(j) = x(1,j)
        worstx(j) = x(npt1,j)
      end do
      bestf = xf(1)
      worstf = xf(npt1)
c
c  COMPUTE THE PARAMETER RANGE FOR THE INITIAL POPULATION
      call parstt2(npt1,nopt,x,xnstd,bound,gnrng,ipcnvg,bbound,bbound2)
c

  201 continue
      rewind(18020)
	write(18020,1812) ix(1), (bestx(j),j=1,nopt)
      write(18011,650) nloop
	write(18011,*)'best result corresponds to simulation' , ix(1)
      write(18011,610) 
	write(18011,630) nloop,icalml,ngs1,gnrng
	do ii=1,iobj
	if (icalpar(2,ii).eq.1) then
	vv= 1.-omin(ii)/nobs(ii)/varval(ii)	
	write(18011,*)'Lowest Nash-Sutcliff efficiency of OF',ii,'=',vv
	end if
	end do

	call parasolunc(iobj,igoc,nopt,icalml,istat, iprob,bbound,
     *	parname, ntot,omin,nobs,nintval, iiname, inrhru, iinr,
     *isens,icalpar, isenspar, sensw, imet)
  301 continue

c
      if (icalml .ge. maxn) go to 9000
      if (ipcnvg .eq. 1) go to 9200
c
c  BEGIN THE MAIN LOOP ----------------
 1000 continue
      nloop = nloop + 1
c
      write (*,*) ' ***  Evolution Loop Number ',nloop

	vartot=0.
	do mm=1,igoc
	varobj(mm)=omin(mm)/nobs(mm)
	vartot=vartot+varobj(mm)
	end do

667	format(100e12.5)
        do i=1, npt1

        xf(i)=0. 
        do mm=1,igoc
	  ffz(mm)=xfz(i,mm)/(varobj(mm)*2)
	  xf(i)= xf(i)+ffz(mm)
        end do
	  xf(i)= xf(i)*vartot
        end do

	call sort3(npt1,nopt,x,xf,xfz,ix,igoc)
	do i = npt1-ngs1, npt1
	icalml = icalml + 1
        call getpnt(nopt,1,iseed1,xx,bl,bu,unit,bl)
        do j = 1, nopt
          x(i,j) = xx(j)
        end do
        xxo=xx

	call functn(xxo,nopt, iiname, inrhru, iinr, icalml,iobj,
     *	 icalpar, isens, isenspar, sensw,obj, imet,icd)
	     xf(i)=0. 
       do mm=1,igoc
        xfz(i,mm)= obj(mm)
        omin(mm)=min(omin(mm), obj(mm))
        ffz(mm)=xfz(i,mm)/(varobj(mm)*2)
	  xf(i)= xf(i)+ffz(mm)
        end do
	  xf(i)= xf(i)*vartot
	write(18019,6666) icalml, (ffz(mm), mm=1,igoc), xf(i)
  	end do	

	call sort3(npt1,nopt,x,xf,xfz,ix,igoc)

c
c  BEGIN LOOP ON COMPLEXES
      do 3000 igs = 1, ngs1
c
c  ASSIGN POINTS INTO COMPLEXES
      do k1 = 1, npg
        k2 = (k1-1) * ngs1 + igs
        do j = 1, nopt
          cx(k1,j) = x(k2,j)
        end do
	  do j = 1, igoc
          cfzq(k1,j) = xfz(k2,j)
        end do
        cfq(k1) = xf(k2)
	  ic(k1)=ix(k2)
      end do
c
c  BEGIN INNER LOOP - RANDOM SELECTION OF SUB-COMPLEXES ---------------
      do 2000 loop = 1, nspl
c
c  CHOOSE A SUB-COMPLEX (nps points) ACCORDING TO A LINEAR
c  PROBABILITY DISTRIBUTION
      if (nps .eq. npg) then
        do k = 1, nps
          lcs(k) = k
        end do
        go to 85
      end if
c
      rand = ran1(iseed1)
      lcs(1) = 1 + dint(npg + 0.5 - dsqrt( (npg+.5)**2 -
     *         npg * (npg+1) * rand ))
      do k = 2, nps
   60   rand = ran1(iseed1)
        lpos = 1 + dint(npg + 0.5 - dsqrt((npg+.5)**2 -
     *         npg * (npg+1) * rand ))
        do k1 = 1, k-1
          if (lpos .eq. lcs(k1)) go to 60
        end do
        lcs(k) = lpos
      end do
c
c  ARRANGE THE SUB-COMPLEX IN ORDER OF INCEASING FUNCTION VALUE
      call sort1(nps,lcs)
c
c  CREATE THE SUB-COMPLEX ARRAYS
   85 do k = 1, nps
        do j = 1, nopt
          s(k,j) = cx(lcs(k),j)
        end do
	  do j = 1, igoc
          sfz(k,j) = cfzq(lcs(k),j)
        end do
        sf(k) = cfq(lcs(k))
	  is(k)=ic(lcs(k))
      end do
c
c  USE THE SUB-COMPLEX TO GENERATE NEW POINT(S)
      call  parasolcce(nopt,nps,s,sf,sfz,bl,bu,xnstd,icalml,maxn,iseed,
     *itel, iiname, inrhru, iinr,iobj,igoc, icalpar, isens, isenspar, 
     * sensw, imet, varobj,omin,npt,is,bbound2,icd)

c
c  IF THE SUB-COMPLEX IS ACCEPTED, REPLACE THE NEW SUB-COMPLEX
c  INTO THE COMPLEX
      do k = 1, nps
        do j = 1, nopt
          cx(lcs(k),j) = s(k,j)
        end do
	  do j = 1, igoc
          cfzq(lcs(k),j) = sfz(k,j)
        end do
        cfq(lcs(k)) = sf(k)
	  ic(lcs(k))=is(k)
      end do

c
c
c  SORT THE POINTS
 
      call sort3(npg,nopt,cx,cfq,cfzq,ic,igoc)
c
c  IF MAXIMUM NUMBER OF RUNS EXCEEDED, BREAK OUT OF THE LOOP
      if (icalml .ge. maxn) go to 2222
c
c  END OF INNER LOOP ------------
 2000 continue
 2222 continue
c
c  REPLACE THE NEW COMPLEX INTO ORIGINAL ARRAY x(.,.)
      do k1 = 1, npg
        k2 = (k1-1) * ngs1 + igs
        do j = 1, nopt
          x(k2,j) = cx(k1,j)
        end do
        do j = 1, igoc
          xfz(k2,j) = cfzq(k1,j)
        end do
        xf(k2) = cfq(k1)
		ix(k2)=ic(k1)
      end do

      if (icalml .ge. maxn) go to 3333
c
c  END LOOP ON COMPLEXES
 3000 continue
c
c  RE-SORT THE POINTS
 3333 call sort3(npt1,nopt,x,xf,xfz,ix,igoc)
c
c  RECORD THE BEST AND WORST POINTS
      do j = 1, nopt
        bestx(j) = x(1,j)
        worstx(j) = x(npt1,j)
      end do
      bestf = xf(1)
      worstf = xf(npt1)

c
c  TEST THE POPULATION FOR PARAMETER CONVERGENCE
      call parstt2(npt1,nopt,x,xnstd,bound,gnrng,ipcnvg,bbound,bbound2)
c
c  PRINT THE RESULTS FOR CURRENT POPULATION

1812  format(i5,100e12.5)
	write(18011,*)'best result corresponds to simulation' , ix(1)
      write(18011,610) 
	write(18011,630) nloop,icalml,ngs1,gnrng
	do ii=1,iobj
	if (icalpar(2,ii).eq.1) then
	vv= 1.-omin(ii)/nobs(ii)/varval(ii)	
	write(18011,*)'Lowest Nash-Sutcliff efficiency of OF',ii,'=',vv
	end if
	end do

	call parasolunc(iobj,igoc,nopt,icalml,istat, iprob,bbound,
     *	parname, ntot,omin,nobs,nintval, iiname, inrhru, iinr,
     *isens,icalpar, isenspar, sensw, imet)


c	write the bestpar file
      rewind(18020)
	write(18020,1812) ix(1), (bestx(j),j=1,nopt)
c
c  TEST IF MAXIMUM NUMBER OF FUNCTION EVALUATIONS EXCEEDED
      if (icalml .ge. maxn) go to 9000
c
c  COMPUTE THE COUNT ON SUCCESSIVE LOOPS W/O FUNCTION IMPROVEMENT
      icrit=1
	
	criter(20) = bestf
      if (nloop .lt. (kstop+1)) go to 132
      denomi = dabs(criter(20-kstop) + criter(20)) / 2.
      timeou = dabs(criter(20-kstop) - criter(20)) / denomi
      if (timeou .ge. pcento) icrit=icrit*0
	do k=1,igoc
      criteromin(20,k) = omin(k)
      denomi = dabs(criteromin(20-kstop,k) + criteromin(20,k)) / 2.
      timeou = dabs(criteromin(20-kstop,k) - criteromin(20,k)) / denomi
      if (timeou .ge. pcento) icrit=icrit*0
	end do
	 if (icrit.eq.1) go to 9100
  132 continue
        do l = 1, 19
        criter(l) = criter(l+1)
      end do
	do k=1,igoc
      do l = 1, 19
        criteromin(l,k) = criteromin(l+1,k)
      end do
	end do
c
c  IF POPULATION IS CONVERGED INTO A SUFFICIENTLY SMALL SPACE
      if (ipcnvg .eq. 1) go to 9200
c
c  NONE OF THE STOPPING CRITERIA IS SATISFIED, CONTINUE SEARCH
c

c
c  END OF MAIN LOOP -----------
      go to 1000
c
c  SEARCH TERMINATED
 9000 continue
      write(18011,800) maxn,loop,igs,nloop
      go to 9999
 9100 continue
      write(18011,810) pcento*100.,kstop
      go to 9999
 9200 write(18011,820) gnrng*100.
 9999 continue
c
c  PRINT THE FINAL PARAMETER ESTIMATE AND ITS FUNCTION VALUE

      rewind(18020)
	write(18020,1812) ix(1), (bestx(j),j=1,nopt)
  801 continue
99988 continue
c
c  END OF SUBROUTINE SCEUA
      return
  400 format(//,2x,50(1h=),/,2x,'ENTER THE SHUFFLED COMPLEX EVOLUTION',
     &       ' GLOBAL SEARCH',/,2x,50(1h=))
  500 format(//,'*** PRINT THE INITIAL CRITERION ',
     &       'VALUE ***')
  510 format(/,' CRITERION',12(6x,a4),/1x,60(1h-))
  520 format(g10.3,12f10.3)
  530 format(10x,12(6x,a4))
  540 format(10x,12f10.3)
  600 format(//,1x,'*** PRINT THE RESULTS OF THE SCE SEARCH ***')
  610 format(/,1x,'LOOP',1x,'TRIALS',1x,'COMPLXS',2x,'PAR RNG')
  640 format(49x,8(f10.3))
  630 format(i5,1x,i5,3x,i5,g10.3)
  650 format(/,1x,'RESULTS FOR LOOP ',i3,/,1x,22(1h-))
  660 format(15x,g10.3,20x,8(f10.3))
  800 format(//,1x,'*** OPTIMIZATION SEARCH TERMINATED BECAUSE THE',
     &       ' LIMIT ON THE MAXIMUM',/,5x,'NUMBER OF TRIALS ',i5,
     &       ' EXCEEDED.  SEARCH WAS STOPPED AT',/,5x,'SUB-COMPLEX ',
     &       i3,' OF COMPLEX ',i3,' IN SHUFFLING LOOP ',i3,' ***')
  810 format(//,1x,'*** OPTIMIZATION TERMINATED BECAUSE THE CRITERION',
     &       ' VALUE HAS NOT CHANGED ',/,5x,f5.2,' PERCENT IN',i3,
     &       ' SHUFFLING LOOPS ***')
  820 format(//,1x,'*** OPTIMIZATION TERMINATED BECAUSE THE POPULATION',
     &       ' HAS CONVERGED INTO ',/,4x,f5.2,' PERCENT OF THE',
     &       ' FEASIBLE SPACE ***')
  830 format(//,'*** PRINT THE FINAL PARAMETER ESTIMATE AND ITS',
     &       ' CRITERION VALUE ***')
      end
c
c
c
c====================================================================
      subroutine parasolcce(nopt,nps,s,sf,sfz,bl,bu,xnstd,icalml,maxn,
     *iseed,itel, iiname, inrhru, iinr,iobj,igoc, icalpar, isens, 
     * isenspar,sensw,imet, varobj, omin,npt,is,bbound2,icd)

c  ALGORITHM GENERATE A NEW POINT(S) FROM A SUB-COMPLEX
c
c  SUB-COMPLEX VARIABLES


      implicit real*8 (a-h,o-z)
      real*8  sensw(isens),obj(iobj), ffz(iobj),varobj(iobj),vartot
      integer iiname(nopt), iinr(nopt),inrhru(nopt,2000),icd
      integer icalpar(4,iobj),isenspar(4,isens),isens, icalml
	integer imet(nopt),igoc,nopt, nps,npt,iseed,itel,iobj
      parameter (c1=0.8,c2=0.4)
      real*8 s(nps,nopt),sf(nps),bu(nopt),bl(nopt),xnstd(nopt)
      real*8 snew(nopt),omin(iobj),sfz(nps,igoc), bbound(2,nopt)
      real*8 bound(nopt),criter(100)
	real*8 bbound2(2,nopt), bu2(nopt), bl2(nopt)
      real*8 swq(nopt),sb(nopt),ce(nopt), a(nopt), unit(nopt)
	integer is(50)
      real*8 fnew
c
c  LIST OF LOCAL VARIABLES
c    sb(.) = the best point of the simplex
c    swq(.) = the worst point of the simplex
c    fwqq = function value of the worst point
c    ce(.) = the centroid of the simplex excluding wo
c    snew(.) = new point generated from the simplex
c    iviol = flag indicating if constraints are violated
c          = 1 , yes
c          = 0 , no


	unit=1.
	do i=1,nopt
	!!!   code added by Nancy 04/07/2006 
!!!   bbound2(1,i) and bbound2(2,i) got too small for compiler
      if (bbound2(1,i) < 1.e-6) bbound2(1,i) = 0.0
	if (bbound2(2,i) < 1.e-6) bbound2(2,i) = 0.0
!!!   end code added
	bl2(i)=bbound2(1,i)
	bu2(i)=bbound2(2,i)
	bbound(1,i)=bl(i)
	bbound(2,i)=bu(i)
	end do
c
c  EQUIVALENCE OF VARIABLES FOR READABILTY OF CODE
	vartot=0.
	do mm=1,igoc
	vartot=vartot+varobj(mm)
	end do
      n = nps
      m = nopt
      alpha = 1.0
      beta = 0.2
c
c  IDENTIFY THE WORST POINT wo OF THE SUB-COMPLEX s
c  COMPUTE THE CENTROID ce OF THE REMAINING POINTS
c  COMPUTE step, THE VECTOR BETWEEN wo AND ce
c  IDENTIFY THE WORST FUNCTION VALUE fwqq
      do j = 1, m
        sb(j) = s(1,j)
        swq(j) = s(n,j)
        ce(j) = 0.0
        do i = 1, n-1
          ce(j) = ce(j) + s(i,j)
        end do
        ce(j) = ce(j)/dble(n-1)
      end do
      fwqq = sf(n)
c
c  COMPUTE THE NEW POINT snew
c
	do kk=1,2
c
c  CHECK IF snew SATISFIES ALL CONSTRAINTS
      call chkcst(nopt,snew,bl,bu,ibound)

c  FIRST TRY A REFLECTION STEP
      do j = 1, m
      snew(j) = ce(j) + alpha * (ce(j) - swq(j))/kk
      end do
c
c  CHECK IF snew SATISFIES ALL CONSTRAINTS
      call chkcst(nopt,snew,bl,bu,ibound)
c
c
c  snew IS OUTSIDE THE BOUND,
c  CHOOSE A POINT AT RANDOM WITHIN FEASIBLE REGION ACCORDING TO
c  A NORMAL DISTRIBUTION WITH BEST POINT OF THE SUB-COMPLEX
c  AS MEAN AND STANDARD DEVIATION OF THE POPULATION AS STD
c      if (ibound .ge. 1) call getpnt(nopt,2,iseed,snew,bl,bu,xnstd,
c     *sb)
      if (ibound .ge. 1)call getpnt2(nopt,iseed,snew,bl,bu,bl2,bu2)
c
c
c  COMPUTE THE FUNCTION VALUE AT snew
      itel=itel+1
	icalml=icalml+1
	call functn(snew,nopt, iiname, inrhru, iinr, icalml,iobj,
     *	 icalpar, isens, isenspar, sensw,obj, imet,icd)
        fnew=0.
	  do mm=1,igoc
	  ffz(mm)=obj(mm)/(varobj(mm)*2)
	  fnew= fnew+ffz(mm)
	  omin(mm)=min(omin(mm),obj(mm))
        end do
	  fnew=fnew*vartot
	  write(18019,6666) icalml, (ffz(mm), mm=1,igoc), fnew

6666    format(i5, 41e12.5)	
c
c  COMPARE fnew WITH THE WORST FUNCTION VALUE fwqq
c
c  fnew IS LESS THAN fwqq, ACCEPT THE NEW POINT snew AND RETURN
      if (fnew .le. fwqq) go to 2000
      if (itel .ge. maxn) go to 3000
	end do
c
c
c  fnew IS GREATER THAN fwqq, SO TRY A CONTRACTION STEP
      do j = 1, m
        snew(j) = ce(j) - beta * (ce(j) - swq(j))
      end do
c
c  COMPUTE THE FUNCTION VALUE OF THE CONTRACTED POINT
      itel=itel+1
	icalml=icalml+1
	call functn(snew,nopt, iiname, inrhru, iinr, icalml,iobj,
     *	 icalpar, isens, isenspar, sensw,obj, imet,icd )
        fnew=0.
	  do mm=1,igoc
	  ffz(mm)=obj(mm)/(varobj(mm)*2)
	  fnew= fnew+ffz(mm)
	  omin(mm)=min(omin(mm),obj(mm))
        end do
	  fnew=fnew*vartot
	write(18019,6666) icalml, (ffz(mm), mm=1,igoc), fnew
c
c  COMPARE fnew TO THE WORST VALUE fwqq
c  IF fnew IS LESS THAN OR EQUAL TO fwqq, THEN ACCEPT THE POINT AND RETURN
      if (fnew .le. fwqq) go to 2000
      if (itel .ge. maxn) go to 3000
c
c
c  IF BOTH REFLECTION AND CONTRACTION FAIL, CHOOSE ANOTHER POINT
c  ACCORDING TO A NORMAL DISTRIBUTION WITH BEST POINT OF THE SUB-COMPLEX
c  AS MEAN AND STANDARD DEVIATION OF THE POPULATION AS STD

 1000 if (ibound .ge. 1) call getpnt2(nopt,iseed,snew,bl,bu,bl2,bu2)
c     call getpnt(nopt,2,iseed,snew,bl,bu,xnstd,sb)
c
c  COMPUTE THE FUNCTION VALUE AT THE RANDOM POINT
      itel=itel+1
	icalml=icalml+1
	call functn(snew,nopt, iiname, inrhru, iinr, icalml,iobj,
     *	 icalpar, isens, isenspar, sensw,obj, imet,icd)
        fnew=0.
	  do mm=1,igoc
	  ffz(mm)=obj(mm)/(varobj(mm)*2)
	  fnew= fnew+ffz(mm)
	  omin(mm)=min(omin(mm),obj(mm))
        end do
	  fnew=fnew*vartot
	write(18019,6666) icalml, (ffz(mm), mm=1,igoc), fnew
c
c
c  REPLACE THE WORST POINT BY THE NEW POINT
 2000 continue

      do j = 1, m
        s(n,j) = snew(j)
      end do
      do j = 1, igoc
        sfz(n,j) = obj(j)
      end do
	sf(n) = fnew
	is(n)=icalml
 3000 continue

1812  format(i5,100e12.3)

c  END OF SUBROUTINE uncce
      return
      end
c
c
c===================================================================
      subroutine sort3(n,m,rb,raq,rbf,im,igoc)

c
c  SORTING SUBROUTINE ADAPTED FROM "NUMERicalm RECIPES"
c  BY W.H. PRESS ET AL., pp. 233-234
c
c  LIST OF VARIABLES
c     raq(.) = array to be sorted
c     rb(.,.) = arrays ordered corresponding to rearrangement of ra(.)
c     wk(.,.), iwk(.), in() = local varibles
c
      real*8  raq(n),rb(n,100),wk(n,100)
	real*8  rbf(n,igoc)
	integer im(n), in(n),n,igoc,m,iwk(n)

      call indexx(n, raq, iwk)

      do 11 i = 1, n
      wk(i,1) = raq(i)
	in(i)=im(i)
   11 continue
      do 12 i = 1, n
      raq(i) = wk(iwk(i),1)
	im(i)=in(iwk(i))
   12 continue
      do 14 j = 1, m
      do 13 i = 1, n
      wk(i,j) = rb(i,j)
   13 continue
   14 continue
      do 16 j = 1, m
      do 15 i = 1, n
      rb(i,j) = wk(iwk(i),j)
   15 continue
   16 continue
      do 18 j = 1, igoc
      do 17 i = 1, n
      wk(i,j) = rbf(i,j)
   17 continue
   18 continue
      do 20 j = 1, igoc
      do 19 i = 1, n
      rbf(i,j) = wk(iwk(i),j)
   19 continue
   20 continue
c  END OF SUBROUTINE SORT
      return
      end
c
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

	subroutine parasolunc(iobj,igoc,nopt,icalml,istat, iprob,bbound,
     *	parname, ntot,omin,nobs,m,    iiname, inrhru, iinr,
     *isens,icalpar, isenspar, sensw, imet)
	character*10 parname(iobj)
c	calculates uncertainty
c	written by Ann van Griensven - University of California Riverside, april 2003


      real*8  sensw(isens), objfmin,objflim

	real*8 varobj(iobj), oflim(iobj),vobj(iobj),vresp(isens)
	real*8 parmn(nopt),parmx(nopt), bbound(2,nopt),vpar(nopt)
	real*8 objmx(iobj),respmn(isens),respmx(isens)
	real*8 respmng(isens),respmxg(isens),ff,omin(iobj)
	real*8 parr(nopt),objr(iobj),respr(isens), xp(nopt), yp(nopt)
	real*8 objgmx(iobj), objgmn(iobj)		
	integer isenspar(4,isens), imet(nopt)
	integer  m,ntot,igoc, istat, iprob
	integer  iiname(nopt), iinr(nopt), inrhru(nopt,2000),nobs(iobj)
	integer iobj,nopt,isens,icalml,icalpar(4,iobj)
	integer ipg(nopt,21),ipb(nopt,21),ipp(nopt)
	write(18011, *)
	write(18011, *)
	write(18011, *) '*** UNCERTAINTY ANALYSIS RESULT ***'
	write(18011, *)
	ntot=0
	do mm=1,iobj
	    varobj(mm)=omin(mm)/nobs(mm)
		ntot=ntot+nobs(mm)
	end do

	select case (istat)
	case (1)
	write(18011, *) 'Results using Xi squared statistics'
	call xiunc(omin,nobs,nopt,igoc,iprob,icalml,objflim,objfmin)
	case (2)
	write(18011, *) 'Results using Bayesian statistics'
	call bayes(m,omin,nobs,nopt,igoc,iprob,icalml,objflim,
     *	objfmin,bbound)
	end select

	objgmx=-1.e20
	objmx=-1.e20
	
	respmxg=0.
	respmx=0.
	omin=1.e20
	objgmn=1.e20
	respmn=1.e20
	respmng=1.e20
	parmn=1.e20
	parmx=-1.e20
	islc=0

	write(*,*) 'objective function limit',objflim

	do j=1,nopt
	parmn(j)=bbound(2,j)
	parmx(j)=bbound(1,j)
	end do

	rewind(18014)
	rewind(18012)
      rewind(18018)
	rewind(19013)
	rewind(19014)
      rewind(19012)
	read(18012,*)
	do i=1,icalml


		read(18012,5) ik,(vobj(kk), kk=1,iobj)
		read(18018,18) ik,ii,(vpar(kk),kk=1,nopt),t
			read(18014,5, end=66) ik,(vresp(kk), kk=1,isens)

			do j=1,isens
			respmx(j)=max(respmx(j),vresp(j))
			respmn(j)=min(respmn(j),vresp(j))
			end do
66	continue
				do j=1,iobj
			omin(j)=min(omin(j),vobj(j))
			objmx(j)=max(objmx(j),vobj(j))
			end do
		if (t/objflim.le.1.01) then
		do j=1,nopt
		parmn(j)=min(parmn(j),vpar(j))
		parmx(j)=max(parmx(j),vpar(j))
		end do
			do j=1,iobj
		    objgmn(j)=min(objgmn(j),vobj(j))
			objgmx(j)=max(objgmx(j),vobj(j))
			end do
			write(19012,5) i,(vobj(kk), kk=1,iobj)

			write(19013,5) i,(vpar(kk),kk=1,nopt)
	if (isens.gt.0) then
			write(19014,5) i,(vresp(kk), kk=1,isens)
			do j=1,isens
			respmxg(j)=max(respmxg(j),vresp(j))
			respmng(j)=min(respmng(j),vresp(j))
			end do
	end if
			do j=1,nopt
			parmx(j)=max(parmx(j),vpar(j))
			parmn(j)=min(parmn(j),vpar(j))
		    ip=int((vpar(j)-bbound(1,j))*20./(bbound(2,j)-bbound(1,j)))
			ipg(j,ip+1)=ipg(j,ip+1)+1
			ipg(j,21)=ipg(j,21)+1
			end do	
			islc=islc+1
			end if
	end do
	do j=1,nopt
	parr(j)=(parmx(j)-parmn(j))*100./(bbound(2,j)-bbound(1,j))
	end do
	do j=1,isens
	respr(j)=(respmxg(j)-respmng(j))*100./(respmx(j)-respmn(j))
	end do

	write(18011,*)'*****statistics of the entire space*****'
	write(18011,*) 'minimum global objective function', objfmin
	write(18011,*) 'total number of runs = ', icalml
	write(18011,*) 'minimum objective functions'
	write(18011,6) (omin(kk), kk=1,iobj)
	write(18011,*) 'maximum objective function values'
	write(18011,6) (objmx(kk),kk=1,iobj)	
	write(18011,*)
	write(18011,*) 'minimum output values'
	write(18011,6) (respmn(kk),kk=1,isens)
	write(18011,*) 'maximum output values'
	write(18011,6) (respmx(kk),kk=1,isens)
	write(18011,*)

	write(18011,*)'*****statistics of selected space  *****'
	select case (iprob)
	case (1)
	write(18011,*) '90% probability uncertainty analysis' 
	case (2)
	write(18011,*) '95% probability uncertainty analysis' 
	case (3)
	write(18011,*) '97.5% probability uncertainty analysis' 
	end select
	write(18011,*) ' Total number of observations = ',nobstot 
	write(18011,*) ' Number of free parameters = ',nopt
	write(18011,*) ' Limit on global objective function = ', objflim

	write(18011,*) ' number of selections', islc
	write(*,*) ' number of selections', islc
	write(18011,*)

	write(18011,*)'minimum parameter values'
	write(18011,6) (parmn(kk), kk=1,nopt)
	write(18011,*)'maximum parameter values'
	write(18011,6) (parmx(kk), kk=1,nopt)
	write(18011,*)'percentage of range '
	write(18011,7) (parr(kk), kk=1,nopt)
	write(18011,*)
	write(18011,*) 'mimimum objective function values'
	write(18011,6) (objgmn(kk), kk=1,iobj)
	write(18011,*) 'maximum objective function values'
	write(18011,6) (objgmx(kk),kk=1,iobj)	
	write(18011,*)
	write(18011,*)'minimum output values'
	write(18011,6) (respmng(kk),kk=1,isens)
	write(18011,*)'maximum output values'
	write(18011,6) (respmxg(kk),kk=1,isens)
	write(18011,*)'percentage of range'
	write(18011,7) (respr(kk),kk=1,isens)

7	format(5x,100f12.5)
6	format(5x,100e12.5)
5	format(i5,100e12.5)
18	format(2i5,100e12.5)
111	continue
	return
	end


ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc	
        subroutine sorteer4(arr,len,ira)
        integer len, ira(len)
        real*8 arr(len)
        lenn=len
	  do ii=1,len
	  ira(ii)=ii
	  end do
        do ii=1,len
         lenn=lenn-1
         help1=arr(1)
          do jj=1,lenn
            help1=arr(jj)
            help2=arr(jj+1)
            if (help2.gt.help1) then
            arr(jj)=help2
            arr(jj+1)=help1
		  it=ira(jj)			
	      ira(jj)=ira(jj+1)
	      ira(jj+1)=it
          end if
          end do
          end do
         return
         end

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc


	subroutine xiunc(omin,nobs,nopt,igoc,iprob,icalml,objflim,objfmin)
c	this subroutine calculates the threshold on the objective function based on 
c	XI-Squared statisitics	 
c	written by Ann van Griensven - University of California Riverside, april 2003

	real*8 vobj(igoc), vpar(nopt), omin(igoc), varobj(igoc)
	integer nobs(igoc), iprob, nopt
	real*8 objfmin, objflim, bestpar(nopt)
	rewind(18014)
	rewind(18012)
      rewind(18013)
	rewind(18020) 
	rewind(18018)
	read(18012,*)
	ii=0
	objfmin=1.e10

	do mm=1,igoc
	  varobj(mm)=omin(mm)/nobs(mm)
	end do
	do i=1,icalml
			read(18012,5) ik,(vobj(kk), kk=1,igoc)
			read(18013,5) ik,(vpar(kk),kk=1,nopt)

		objf=0.
		do mm=1,igoc
		objf=objf+vobj(mm)/(varobj(mm)*2)
		end do
	    if (objf.lt.objfmin) then
          objfmin=objf
	    bestpar=vpar
	    isim=i
	    end if
          write(18018,18) i, ii,vpar, objf

18     format(2i5,100e12.5)
5     format(1i5,100e12.5)
	end do
	write(18020,5) isim,(bestpar(kk),kk=1,nopt)
	nobstot=0.
	do mm=1,igoc
	nobstot=nobs(mm)+nobstot
	end do

      objflim=objfmin*(1+xisquare(iprob,nopt)/(nobstot-nopt))
	return
	end

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc	
        subroutine sorteer5(vtot,itot,len)
c	sorts an integer and real matrix according to the real matrix
c	written by Ann van Griensven - University of California Riverside, april 2003

        integer len, itot(len),lenn,ihelp1,ihelp2
        real*8 vtot(len,3), help1(3), help2(3)
        lenn=len
        do ii=1,len
         lenn=lenn-1
           do jj=1,lenn
	      ihelp1=itot(jj)
            ihelp2=itot(jj+1)
		  do n=1,3
		  help1(n)=vtot(jj,n)
            help2(n)=vtot(jj+1,n)
	      end do
            if (help2(1).lt.help1(1)) then
		   do n=1,3
             vtot(jj,n)=help2(n)
    	       vtot(jj+1,n)=help1(n)	
		  end do
		  itot(jj)=ihelp2
	      itot(jj+1)=ihelp1
          end if
          end do
          end do
         return
         end
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc


	subroutine bayes(m,omin,nobs,nopt,igoc,iprob,icalml,objflim,
     *	objfmin,bbound)
c	this subroutine calculates the threshold on the objective function based on 
c	Bayesian statisitics	 
c	written by Ann van Griensven - University of California Riverside, april 2003

	real*8 vobj(igoc), vpar(nopt), omin(igoc), varobj(igoc)
	real*8 bbound(2,nopt), bestpar(nopt)
	integer nobs(igoc),itot(icalml), ipar(icalml,nopt)
	integer ipb(nopt,m)
	real*8 objfmin, objflim,vtot(icalml,3)
	rewind(18014)
	rewind(18012)
      rewind(18013)
	rewind(18018)
	read(18012,*)
	ii=0
	objfmin=1.e10
	ipb=0

	select case (iprob)
	case(1)
	probab=.9
	case(2)
	probab=.95
	case(3)
	probab=.975
	end select
	do mm=1,igoc
	  varobj(mm)=omin(mm)/nobs(mm)
		write(18011,*) varobj(mm), omin(mm), nobs(mm)
	end do

	do i=1,icalml
		itot(i)=i
			read(18012,5) ik,(vobj(kk), kk=1,igoc)
			read(18013,5) ik,(vpar(kk),kk=1,nopt)
		objf=0.
		do mm=1,igoc
		objf=objf+vobj(mm)/(varobj(mm)*2)
		end do
			do j=1,nopt
		    ip=int(m*(vpar(j)-bbound(1,j))/
     *			(bbound(2,j)-bbound(1,j)))+1
	        ip=min(ip,m)
			ipb(j,ip)=ipb(j,ip)+1
	        ipar(i,j)=ip
			end do
	        vtot(i,1)=objf
	    if (objf.lt.objfmin) then
          objfmin=objf
	    bestpar=vpar
	    isim=i
	    end if
          write(18018,18) i, ii,vpar, objf
18     format(2i5,100e12.5)
5     format(1i5,100e12.5)
	end do
	write(18020,5) isim,(bestpar(kk),kk=1,nopt)

	tot=0.
	do i=1,icalml
	    tt=1.
		do  j=1,nopt
		ip=ipar(i,j)
	    t=1.*icalml/m/ipb(j,ip)
		tt=tt*t
		end do
	vtot(i,3)=tt**(1./nopt)
	vtot(i,2)=exp(-vtot(i,1)+objfmin)
		tot=tot+vtot(i,2)*vtot(i,3)
	    totv=totv+vtot(i,3)
	end do
	call sorteer5(vtot,itot,icalml)
	sortot=0.
	do i=1,icalml
	write(11111,18) i, itot(i), vtot(i,1), vtot(i,2), vtot(i,3)
	sortot=sortot+vtot(i,2)*vtot(i,3)/tot
	
	if (sortot.gt.probab) go to 74
	end do
74	continue
      ivt=itot(i)
	objflim=vtot(i,1)
	end
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc	
      subroutine rerunPS(nopt,iobj,isens)
!     !  !         !         !         !         !         !         ! !
c	Main program to rerun the uncertainty analysis
c	written by Ann van Griensven - University of California Riverside, april 2003

!!    iobj         |none          |number of objective functions
!!    obj(:)       |none          |values of the objective functions
!!    iclb         |none          |method to form GOC out of objective functions
!!    icalpar(:,:) |none          |objective functions codes of OBJMET.DAT
!!    iitel        |none          |number of simulation run
!!    iinr(:)      !              |number of HRUs to change for parameter (:)
!!    inrhru(:,:)  |none          |list of HRU numbers to change  

c     AVG



c  THIS SUBROUTINES RERUNS SWAT FOR UNCERTAINTY ON OUTPUT
!     !  !         !         !         !         !         !         ! !
      implicit real*8 (a-h,o-z)
      integer icalpar(4,iobj), iobj, isenspar(4,isens),iprob, imet(nopt)
      integer  iiname(nopt), iinr(nopt), inrhru(nopt,2000),nobs(100)
	integer icalml, igoc,icd,istat
      real*8 a(100), bbound(2,nopt), sensw(isens), omin(iobj),
     *	bestf, varobj(iobj),aveval(iobj), varval(iobj)
      real*8 valmin(iobj), valmax(iobj), xxo(nopt),vobj(iobj)
      character*10 pcntrl,deflt,usrsp, parname(nopt)
      character*8 reduc,initl,ysflg,noflg
      data deflt/' DEFAULT  '/
      data usrsp/'USER SPEC.'/
      data ysflg/'YES '/
      data noflg/'NO  '/

      common /iopar/ in,iprii
   
      open(18009,file='parasolin.dat',status='old')
      open(18011,file='parasolout2.out',status='unknown')
      open(18012, file='sceobjf.out')
	open(18014, file='sceresponse.out')
      open(18013, file='scepar.out')
      open(18018, file='sceparobj.dat')
	open(18019, file='scegoc.out')
	open(19014, file='uncresponse.out')
      open(19013, file='goodpar.out')
      open(19012, file='uncobjf.out')
	open(18020,file='bestpar.out')
		iprii=18011			
	call readchangepar(bbound,nopt,iiname,iinr, inrhru,imet,parname)
	call readmetfiles(iobj,calw, icalpar,isenspar,sensw,
     *	isens)
	call parasolin(maxn,kstop,pcento,iseed,nopt,iobj,npt,
     &  nintval,igoc,ngs,npg,nps,nspl, istat, iprob)

	call countobs(nobs,iobj, icalpar,aveval,varval)
	write(18011, *) 'OF   # obs| average |variance    '
	do ii=1,iobj
	write(18011,121) ii, nobs(ii), aveval(ii),varval(ii)
121   format(i5,i5,2e11.3)	
	end do

	omin=1.e10
	rewind(18012)
	icalml=0
	read(18012,*)
1	read(18012,5,end=3) ik,(vobj(kk), kk=1,iobj)
	do kk=1,iobj
	omin(kk)=min(omin(kk),vobj(kk))
	end do
	icalml=icalml+1
	go to 1 
3     continue

5     format(1i5,100e12.5)
c	omin(1)=121000.
c	omin(2)=2370.
c	omin(3)=36700.
c	omin(4)=171.
c	icalml=1243
c	selecting of acceptible simulations based on objective functions

	call parasolunc(iobj,igoc,nopt,icalml,istat, iprob,bbound,
     *	parname, ntot,omin,nobs,m,    iiname, inrhru, iinr,
     *isens,icalpar, isenspar, sensw, imet)

c	calling subroutine to analyse selection to compute uncertainty
	
	close(18010)
      close(18011)
      close(18012)
      close(18013)
	close(18014)
      close(18016)
	close(18017)
	close(18018)
	close(18019)
	close(18020)
      close(19012)
      close(19013)
	close(19014)
c  END OF THE MAIN PROGRAM
      return
	end

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc	
	real*8 function xisquare(iprob,nopt)	
c	This subroutine calculates the XI-sqared values based on number of parameters (nopt) 
c	and the iprob (confidence percentage)
c	written by Ann van Griensven - University of California Riverside, april 2003

	real*8	xi90,xi95,xi975, xi99, xi999
	
	nopt=min(100,nopt)

	select case(nopt)
	
	case(1)
	xi90 =     2.706
	xi95 =     3.841
	xi975 =     5.024
	xi99 =     6.635
	xi999 =    10.828
 
	case(2)
	xi90 =     4.605
	xi95 =     5.991
	xi975 =     7.378
	xi99 =     9.210
	xi999 =    13.816
 
	case(3)
	xi90 =     6.251
	xi95 =     7.815
	xi975 =     9.348
	xi99 =    11.345
	xi999 =    16.266
 
	case(4)
	xi90 =     7.779
	xi95 =     9.488
	xi975 =    11.143
	xi99 =    13.277
	xi999 =    18.467
 
	case(5)
	xi90 =     9.236
	xi95 =    11.070
	xi975 =    12.833
	xi99 =    15.086
	xi999 =    20.515
 
	case(6)
	xi90 =    10.645
	xi95 =    12.592
	xi975 =    14.449
	xi99 =    16.812
	xi999 =    22.458
 
	case(7)
	xi90 =    12.017
	xi95 =    14.067
	xi975 =    16.013
	xi99 =    18.475
	xi999 =    24.322
 
	case(8)
	xi90 =    13.362
	xi95 =    15.507
	xi975 =    17.535
	xi99 =    20.090
	xi999 =    26.125
 
	case(9)
	xi90 =    14.684
	xi95 =    16.919
	xi975 =    19.023
	xi99 =    21.666
	xi999 =    27.877
 
	case(10)
	xi90 =    15.987
	xi95 =    18.307
	xi975 =    20.483
	xi99 =    23.209
	xi999 =    29.588
 
	case(11)
	xi90 =    17.275
	xi95 =    19.675
	xi975 =    21.920
	xi99 =    24.725
	xi999 =    31.264
 
	case(12)
	xi90 =    18.549
	xi95 =    21.026
	xi975 =    23.337
	xi99 =    26.217
	xi999 =    32.910
 
	case(13)
	xi90 =    19.812
	xi95 =    22.362
	xi975 =    24.736
	xi99 =    27.688
	xi999 =    34.528
 
	case(14)
	xi90 =    21.064
	xi95 =    23.685
	xi975 =    26.119
	xi99 =    29.141
	xi999 =    36.123
 
	case(15)
	xi90 =    22.307
	xi95 =    24.996
	xi975 =    27.488
	xi99 =    30.578
	xi999 =    37.697
 
	case(16)
	xi90 =    23.542
	xi95 =    26.296
	xi975 =    28.845
	xi99 =    32.000
	xi999 =    39.252
 
	case(17)
	xi90 =    24.769
	xi95 =    27.587
	xi975 =    30.191
	xi99 =    33.409
	xi999 =    40.790
 
	case(18)
	xi90 =    25.989
	xi95 =    28.869
	xi975 =    31.526
	xi99 =    34.805
	xi999 =    42.312
 
	case(19)
	xi90 =    27.204
	xi95 =    30.144
	xi975 =    32.852
	xi99 =    36.191
	xi999 =    43.820
 
	case(20)
	xi90 =    28.412
	xi95 =    31.410
	xi975 =    34.170
	xi99 =    37.566
	xi999 =    45.315
 
	case(21)
	xi90 =    29.615
	xi95 =    32.671
	xi975 =    35.479
	xi99 =    38.932
	xi999 =    46.797
 
	case(22)
	xi90 =    30.813
	xi95 =    33.924
	xi975 =    36.781
	xi99 =    40.289
	xi999 =    48.268
 
	case(23)
	xi90 =    32.007
	xi95 =    35.172
	xi975 =    38.076
	xi99 =    41.638
	xi999 =    49.728
 
	case(24)
	xi90 =    33.196
	xi95 =    36.415
	xi975 =    39.364
	xi99 =    42.980
	xi999 =    51.179
 
	case(25)
	xi90 =    34.382
	xi95 =    37.652
	xi975 =    40.646
	xi99 =    44.314
	xi999 =    52.620
 
	case(26)
	xi90 =    35.563
	xi95 =    38.885
	xi975 =    41.923
	xi99 =    45.642
	xi999 =    54.052
 
	case(27)
	xi90 =    36.741
	xi95 =    40.113
	xi975 =    43.195
	xi99 =    46.963
	xi999 =    55.476
 
	case(28)
	xi90 =    37.916
	xi95 =    41.337
	xi975 =    44.461
	xi99 =    48.278
	xi999 =    56.892
 
	case(29)
	xi90 =    39.087
	xi95 =    42.557
	xi975 =    45.722
	xi99 =    49.588
	xi999 =    58.301
 
	case(30)
	xi90 =    40.256
	xi95 =    43.773
	xi975 =    46.979
	xi99 =    50.892
	xi999 =    59.703
 
	case(31)
	xi90 =    41.422
	xi95 =    44.985
	xi975 =    48.232
	xi99 =    52.191
	xi999 =    61.098
 
	case(32)
	xi90 =    42.585
	xi95 =    46.194
	xi975 =    49.480
	xi99 =    53.486
	xi999 =    62.487
 
	case(33)
	xi90 =    43.745
	xi95 =    47.400
	xi975 =    50.725
	xi99 =    54.776
	xi999 =    63.870
 
	case(34)
	xi90 =    44.903
	xi95 =    48.602
	xi975 =    51.966
	xi99 =    56.061
	xi999 =    65.247
 
	case(35)
	xi90 =    46.059
	xi95 =    49.802
	xi975 =    53.203
	xi99 =    57.342
	xi999 =    66.619
 
	case(36)
	xi90 =    47.212
	xi95 =    50.998
	xi975 =    54.437
	xi99 =    58.619
	xi999 =    67.985
 
	case(37)
	xi90 =    48.363
	xi95 =    52.192
	xi975 =    55.668
	xi99 =    59.893
	xi999 =    69.347
 
	case(38)
	xi90 =    49.513
	xi95 =    53.384
	xi975 =    56.896
	xi99 =    61.162
	xi999 =    70.703
 
	case(39)
	xi90 =    50.660
	xi95 =    54.572
	xi975 =    58.120
	xi99 =    62.428
	xi999 =    72.055
 
	case(40)
	xi90 =    51.805
	xi95 =    55.758
	xi975 =    59.342
	xi99 =    63.691
	xi999 =    73.402
 
	case(41)
	xi90 =    52.949
	xi95 =    56.942
	xi975 =    60.561
	xi99 =    64.950
	xi999 =    74.745
 
	case(42)
	xi90 =    54.090
	xi95 =    58.124
	xi975 =    61.777
	xi99 =    66.206
	xi999 =    76.084
 
	case(43)
	xi90 =    55.230
	xi95 =    59.304
	xi975 =    62.990
	xi99 =    67.459
	xi999 =    77.419
 
	case(44)
	xi90 =    56.369
	xi95 =    60.481
	xi975 =    64.201
	xi99 =    68.710
	xi999 =    78.750
 
	case(45)
	xi90 =    57.505
	xi95 =    61.656
	xi975 =    65.410
	xi99 =    69.957
	xi999 =    80.077
 
	case(46)
	xi90 =    58.641
	xi95 =    62.830
	xi975 =    66.617
	xi99 =    71.201
	xi999 =    81.400
 
	case(47)
	xi90 =    59.774
	xi95 =    64.001
	xi975 =    67.821
	xi99 =    72.443
	xi999 =    82.720
 
	case(48)
	xi90 =    60.907
	xi95 =    65.171
	xi975 =    69.023
	xi99 =    73.683
	xi999 =    84.037
 
	case(49)
	xi90 =    62.038
	xi95 =    66.339
	xi975 =    70.222
	xi99 =    74.919
	xi999 =    85.351
 
	case(50)
	xi90 =    63.167
	xi95 =    67.505
	xi975 =    71.420
	xi99 =    76.154
	xi999 =    86.661
 
	case(51)
	xi90 =    64.295
	xi95 =    68.669
	xi975 =    72.616
	xi99 =    77.386
	xi999 =    87.968
 
	case(52)
	xi90 =    65.422
	xi95 =    69.832
	xi975 =    73.810
	xi99 =    78.616
	xi999 =    89.272
 
	case(53)
	xi90 =    66.548
	xi95 =    70.993
	xi975 =    75.002
	xi99 =    79.843
	xi999 =    90.573
 
	case(54)
	xi90 =    67.673
	xi95 =    72.153
	xi975 =    76.192
	xi99 =    81.069
	xi999 =    91.872
 
	case(55)
	xi90 =    68.796
	xi95 =    73.311
	xi975 =    77.380
	xi99 =    82.292
	xi999 =    93.168
 
	case(56)
	xi90 =    69.919
	xi95 =    74.468
	xi975 =    78.567
	xi99 =    83.513
	xi999 =    94.461
 
	case(57)
	xi90 =    71.040
	xi95 =    75.624
	xi975 =    79.752
	xi99 =    84.733
	xi999 =    95.751
 
	case(58)
	xi90 =    72.160
	xi95 =    76.778
	xi975 =    80.936
	xi99 =    85.950
	xi999 =    97.039
 
	case(59)
	xi90 =    73.279
	xi95 =    77.931
	xi975 =    82.117
	xi99 =    87.166
	xi999 =    98.324
 
	case(60)
	xi90 =    74.397
	xi95 =    79.082
	xi975 =    83.298
	xi99 =    88.379
	xi999 =    99.607
 
	case(61)
	xi90 =    75.514
	xi95 =    80.232
	xi975 =    84.476
	xi99 =    89.591
	xi999 =   100.888
 
	case(62)
	xi90 =    76.630
	xi95 =    81.381
	xi975 =    85.654
	xi99 =    90.802
	xi999 =   102.166
 
	case(63)
	xi90 =    77.745
	xi95 =    82.529
	xi975 =    86.830
	xi99 =    92.010
	xi999 =   103.442
 
	case(64)
	xi90 =    78.860
	xi95 =    83.675
	xi975 =    88.004
	xi99 =    93.217
	xi999 =   104.716
 
	case(65)
	xi90 =    79.973
	xi95 =    84.821
	xi975 =    89.177
	xi99 =    94.422
	xi999 =   105.988
 
	case(66)
	xi90 =    81.085
	xi95 =    85.965
	xi975 =    90.349
	xi99 =    95.626
	xi999 =   107.258
 
	case(67)
	xi90 =    82.197
	xi95 =    87.108
	xi975 =    91.519
	xi99 =    96.828
	xi999 =   108.526
 
	case(68)
	xi90 =    83.308
	xi95 =    88.250
	xi975 =    92.689
	xi99 =    98.028
	xi999 =   109.791
 
	case(69)
	xi90 =    84.418
	xi95 =    89.391
	xi975 =    93.856
	xi99 =    99.228
	xi999 =   111.055
 
	case(70)
	xi90 =    85.527
	xi95 =    90.531
	xi975 =    95.023
	xi99 =   100.425
	xi999 =   112.317
 
	case(71)
	xi90 =    86.635
	xi95 =    91.670
	xi975 =    96.189
	xi99 =   101.621
	xi999 =   113.577
 
	case(72)
	xi90 =    87.743
	xi95 =    92.808
	xi975 =    97.353
      xi99 =   102.816
	xi999 =   114.835
 
	case(73)
	xi90 =    88.850
	xi95 =    93.945
	xi975 =    98.516
	xi99 =   104.010
	xi999 =   116.092
 
	case(74)
	xi90 =    89.956
	xi95 =    95.081
	xi975 =    99.678
	xi99 =   105.202
	xi999 =   117.346
 
	case(75)
	xi90 =    91.061
	xi95 =    96.217
	xi975 =   100.839
	xi99 =   106.393
	xi999 =   118.599
 
	case(76)
	xi90 =    92.166
	xi95 =    97.351
	xi975 =   101.999
	xi99 =   107.583
	xi999 =   119.850
 
	case(77)
	xi90 =    93.270
	xi95 =    98.484
	xi975 =   103.158
	xi99 =   108.771
	xi999 =   121.100
 
	case(78)
	xi90 =    94.374
	xi95 =    99.617
	xi975 =   104.316
	xi99 =   109.958
	xi999 =   122.348
 
	case(79)
	xi90 =    95.476
	xi95 =   100.749
	xi975 =   105.473
	xi99 =   111.144
	xi999 =   123.594
 
	case(80)
	xi90 =    96.578
	xi95 =   101.879
	xi975 =   106.629
	xi99 =   112.329
	xi999 =   124.839
 
	case(81)
	xi90 =    97.680
	xi95 =   103.010
	xi975 =   107.783
	xi99 =   113.512
	xi999 =   126.083
 
	case(82)
	xi90 =    98.780
	xi95 =   104.139
	xi975 =   108.937
	xi99 =   114.695
	xi999 =   127.324
 
	case(83)
	xi90 =    99.880
	xi95 =   105.267
	xi975 =   110.090
	xi99 =   115.876
	xi999 =   128.565
 
	case(84)
	xi90 =   100.980
	xi95 =   106.395
	xi975 =   111.242
	xi99 =   117.057
	xi999 =   129.804
 
	case(85)
	xi90 =   102.079
	xi95 =   107.522
	xi975 =   112.393
	xi99 =   118.236
	xi999 =   131.041
 
	case(86)
	xi90 =   103.177
	xi95 =   108.648
	xi975 =   113.544
	xi99 =   119.414
	xi999 =   132.277
 
	case(87)
	xi90 =   104.275
	xi95 =   109.773
	xi975 =   114.693
	xi99 =   120.591
	xi999 =   133.512
 
	case(88)
	xi90 =   105.372
	xi95 =   110.898
	xi975 =   115.841
	xi99 =   121.767
	xi999 =   134.746
 
	case(89)
	xi90 =   106.469
	xi95 =   112.022
	xi975 =   116.989
	xi99 =   122.942
	xi999 =   135.978
 
	case(90)
	xi90 =   107.565
	xi95 =   113.145
	xi975 =   118.136
	xi99 =   124.116
	xi999 =   137.208
 
	case(91)
	xi90 =   108.661
	xi95 =   114.268
	xi975 =   119.282
	xi99 =   125.289
	xi999 =   138.438
 
	case(92)
	xi90 =   109.756
	xi95 =   115.390
	xi975 =   120.427
	xi99 =   126.462
	xi999 =   139.666
 
	case(93)
	xi90 =   110.850
	xi95 =   116.511
	xi975 =   121.571
	xi99 =   127.633
	xi999 =   140.893
 
	case(94)
	xi90 =   111.944
	xi95 =   117.632
	xi975 =   122.715
	xi99 =   128.803
	xi999 =   142.119
 
	case(95)
	xi90 =   113.038
	xi95 =   118.752
	xi975 =   123.858
	xi99 =   129.973
	xi999 =   143.344
 
	case(96)
	xi90 =   114.131
	xi95 =   119.871
	xi975 =   125.000
	xi99 =   131.141
	xi999 =   144.567
 
	case(97)
	xi90 =   115.223
	xi95 =   120.990
	xi975 =   126.141
	xi99 =   132.309
	xi999 =   145.789
 
	case(98)
	xi90 =   116.315
	xi95 =   122.108
	xi975 =   127.282
	xi99 =   133.476
	xi999 =   147.010
 
	case(99)
	xi90 =   117.407
	xi95 =   123.225
	xi975 =   128.422
	xi99 =   134.642
	xi999 =   148.230
 
	case(100)
	xi90 =   118.498
	xi95 =   124.342
	xi975 =   129.561
	xi99 =   135.807
	xi999 =   149.449
 
	end select
	
	select case(iprob)
	case(1)
		 xisquare=xi90
	case(2)
		 xisquare=xi95
	case(3)
		 xisquare=xi975
    	case(4)
		 xisquare=xi99
	case(5)
		 xisquare=xi999
	end select
	return
	end
c===================================================================
	subroutine getpnt2(nopt,iseed, x,bl,bu,bl2,bu2)
c
c     This subroutine generates a new point within feasible region
c
c     x(.) = new point
c     xi(.) = focal point
c     bl(.) = lower bound
c     bu(.) = upper bound
c     std(.) = standard deviation of probability distribution
c     idistq = probability flag
c           = 1 - uniform distribution
c           = 2 - Gaussian distribution
c
      implicit real*8 (a-h,o-z)
      real*8 x(nopt),bl(nopt),bu(nopt),std(nopt),xi(nopt)
	real*8 bl2(nopt), bu2(nopt)
      do i = 1, nopt
	x(i)=max(x(i),bl(i))
	x(i)=min(x(i),bu(i))
	end do
      return
      end
c
c
c
c===================================================================


      subroutine getpnt(nopt,idistq,iseed,x,bl,bu,std,xi)
c
c     This subroutine generates a new point within feasible region
c
c     x(.) = new point
c     xi(.) = focal point
c     bl(.) = lower bound
c     bu(.) = upper bound
c     std(.) = standard deviation of probability distribution
c     idistq = probability flag
c           = 1 - uniform distribution
c           = 2 - Gaussian distribution
c
      implicit real*8 (a-h,o-z)
      real*8 x(nopt),bl(nopt),bu(nopt),std(nopt),xi(nopt)
        do 1921 i = 1, nopt



 1921 continue

c
    1 do j=1, nopt
    2   if (idistq .eq. 1) rand = ran1(iseed)
        if (idistq .eq. 2) rand = gasdev(iseed)
        x(j) = xi(j) + std(j) * rand * (bu(j) - bl(j))

c
c     Check explicit constraints
c        
        call chkcst(1,x(j),bl(j),bu(j),ibound)
        if (ibound .ge. 1) go to 2


      end do
c
c     Check implicit constraints
c      
      call chkcst(nopt,x,bl,bu,ibound)
      if (ibound .ge. 1) go to 1
c
      return
      end
c
c
c
c===================================================================
      subroutine parstt2(npt,nopt,x,xnstd,bound,gnrng,ipcnvg, bbound
     *	,bbound2)

c
c  SUBROUTINE CHECKING FOR PARAMETER CONVERGENCE
      implicit real*8 (a-h,o-z)
      real*8 x(npt,nopt),xmaxq(nopt),xminq(nopt)
      real*8 xmean(nopt),xnstd(nopt),bound(nopt)
	real*8 xnstd2(nopt), xmean2(nopt), bbound(2,nopt),bbound2(2,nopt)
      parameter (delta = 1.0d-20,peps=1.0d-3)
c
c  COMPUTE MAXIMUM, MINIMUM AND STANDARD DEVIATION OF PARAMETER VALUES
      gsum = 0.d0
      do k = 1, nopt
        xmaxq(k) = -1.0d+20
        xminq(k) = 1.0d+20
        xsum1 = 0.d0
        xsum2 = 0.d0
        do i = 1, npt
          xmaxq(k) = dmax1(x(i,k), xmaxq(k))
          xminq(k) = dmin1(x(i,k), xminq(k))
          xsum1 = xsum1 + x(i,k)
          xsum2 = xsum2 + x(i,k)*x(i,k)
        end do

        if (xmaxq(k).lt.xminq(k)) xmaxq(k)=xminq(k)
        xmean2(k) = xsum1 / dble(npt)
        xnstd2(k) = (xsum2 / dble(npt) - xmean2(k)*xmean2(k))
        if (xnstd2(k) .le. delta) xnstd2(k) = delta
        xnstd2(k) = dsqrt(xnstd2(k))
        xnstd2(k) = xnstd2(k) / bound(k)
	xmean(k)=(bbound(2,k)-bbound(1,k))/2.
	xnstd(k)=0.5
        gsum = gsum + dlog( delta + (xmaxq(k)-xminq(k))/bound(k) )
c	bbound2(2,k)=min(xmaxq(k)+0.05/bound(k), bbound(2,k))
c	bbound2(1,k)=max(xminq(k)-0.05/bound(k),bbound(1,k)) 
      end do
      gnrng = dexp(gsum/dble(nopt))

c
c  CHECK IF NORMALIZED STANDARD DEVIATION OF PARAMETER IS <= eps
      ipcnvg = 0
      if (gnrng .le. peps) then
        ipcnvg = 1
      end if
c
c  END OF SUBROUTINE PARSTT
      return
      end
c
c
cc===========================================================
      subroutine sort1(n,raq)

c
c
c  SORTING SUBROUTINE ADAPTED FROM "NUMERicalm RECIPES"
c  BY W.H. PRESS ET AL., pp. 231
c
c  LIST OF VARIABLES
c     raq(.) = integer array to be sorted
c
      implicit real*8 (a-h,o-z)
      dimension raq(n)
c
      integer raq, rra
c
      l = (n / 2) + 1
      ir = n
   10 continue
      if (l .gt. 1) then
      l = l - 1
      rra = raq(l)
      else
      rra = raq(ir)
      raq(ir) = raq(1)
      ir = ir - 1
      if (ir .eq. 1) then
      raq(1) = rra
      return
      end if
      end if
      i = l
      j = l + l
   20 if (j .le. ir) then
      if (j .lt. ir) then
      if (raq(j) .lt. raq(j + 1)) j = j + 1
      end if
      if (rra .lt. raq(j)) then
      raq(i) = raq(j)
      i = j
      j = j + j
      else
      j = ir + 1
      end if
      goto 20
      end if
      raq(i) = rra
      goto 10
c
c  END OF SUBROUTINE SORT1
      end
c
c
c
c=======================================================
      subroutine indexx(n, arrin, indx)
c
c
c  THIS SUBROUTINE IS FROM "NUMERicalm RECIPES" BY PRESS ET AL.
      real*8  arrin(n),q
      integer indx(n)
c
      do 11 j = 1, n
      indx(j) = j
   11 continue
      l = (n / 2) + 1
      ir = n
   10 continue
      if (l .gt. 1) then
      l = l - 1
      indxt = indx(l)
      q = arrin(indxt)
      else
      indxt = indx(ir)
      q = arrin(indxt)
      indx(ir) = indx(1)
      ir = ir - 1
      if (ir .eq. 1) then
      indx(1) = indxt
      return
      end if
      end if
      i = l
      j = l + l
   20 if (j .le. ir) then
      if (j .lt. ir) then
      if (arrin(indx(j)) .lt. arrin(indx(j + 1))) j = j + 1
      end if
      if (q .lt. arrin(indx(j))) then
      indx(i) = indx(j)
      i = j
      j = j + j
      else
      j = ir + 1
      end if
      goto 20
      end if
      indx(i) = indxt
      goto 10
c
c  END OF SUBROUTINE INDEXX
      end
c
c
c
c==============================================================
      real*8 function ran1(idum)
c
c
c  THIS SUBROUTINE IS FROM "NUMERICAL RECIPES" BY PRESS ET AL.
      implicit real*8 (a-h,o-z)
      dimension rqq(97)
      parameter (m1 = 259200, ia1 = 7141, ic1 = 54773, rm1 =
     &3.8580247e-6)
      parameter (m2 = 134456, ia2 = 8121, ic2 = 28411, rm2 =
     &7.4373773e-6)
      parameter (m3 = 243000, ia3 = 4561, ic3 = 51349)
      save
      data iff / 0 /
      if ((idum .lt. 0) .or. (iff .eq. 0)) then
      iff = 1
      ix1 = mod(ic1 - idum,m1)
      ix1 = mod((ia1 * ix1) + ic1,m1)
      ix2 = mod(ix1,m2)
      ix1 = mod((ia1 * ix1) + ic1,m1)
      ix3 = mod(ix1,m3)
      do 11 j = 1, 97
      ix1 = mod((ia1 * ix1) + ic1,m1)
      ix2 = mod((ia2 * ix2) + ic2,m2)
      rqq(j) = (dble(ix1) + (dble(ix2) * rm2)) * rm1
   11 continue
      idum = 1
      end if
      ix1 = mod((ia1 * ix1) + ic1,m1)
      ix2 = mod((ia2 * ix2) + ic2,m2)
      ix3 = mod((ia3 * ix3) + ic3,m3)
      j = 1 + ((97 * ix3) / m3)
      if ((j .gt. 97) .or. (j .lt. 1)) pause
      ran1 = rqq(j)
      rqq(j) = (dble(ix1) + (dble(ix2) * rm2)) * rm1
c
c  END OF SUBROUTINE RAN1
      return
      end
c
c
c
c===============================================================
      real*8 function gasdev(idum)

c
c
c  THIS SUBROUTINE IS FROM "NUMERicalm RECIPES" BY PRESS ET AL.
      implicit real*8 (a-h,o-z)
      common /gasblk/ iset
      data iset / 0 /
      if (iset .eq. 0) then
    1 v1 = (2. * ran1(idum)) - 1.
      v2 = (2. * ran1(idum)) - 1.
      rqq = (v1 ** 2) + (v2 ** 2)
      if (rqq .ge. 1.) goto 1
      fac = sqrt(- ((2. * log(rqq)) / rqq))
      gset = v1 * fac
      gasdev = v2 * fac
      iset = 1
      else
      gasdev = gset
      iset = 0
      end if
c
c  END OF SUBROUTINE GASDEV
      return
      end

c
      subroutine sorteer2(arr,len)
         integer len
         real(8) arr(len),help1,help2

         lenn=len
         do ii=1,len
           lenn=lenn-1
           help1=arr(1)
           do jj=1,lenn
            help1=arr(jj)
            help2=arr(jj+1)
          if (help2.lt.help1) then
            arr(jj)=help2
            arr(jj+1)=help1
         end if
         end do
        end do
        return
        end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      subroutine chkcst(nopt,xi,bl,bu,ibound)
c
c     This subroutine check if the trial point satisfies all
c     constraints.
c
c     ibound - violation indicator
c            = -1 initial value
c            = 0  no violation
c            = 1  violation
c     nopt = number of optimizing variables
c     ii = the ii'th variable of the arrays x, bl, and bu
c
      implicit real*8 (a-h,o-z)
      dimension xi(nopt),bl(nopt),bu(nopt)
c
      ibound = -1
c
c     Check if explicit constraints are violated
c
      do ii=1, nopt
        if (xi(ii) .lt. bl(ii) .or. xi(ii) .gt. bu(ii)) go to 10
      end do
      if (nopt .eq. 1) go to 9
c
c     Check if implicit constraints are violated
c     (no implicit constraints for this function)
c
c     No constraints are violated
c
    9 ibound = 0
      return
c
c     At least one of the constraints are violated
c
   10 ibound = 1
      return
      end
